unit HVteiler;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, math;

const
  E6: array[0..5]  of integer = (10, 15, 22, 33, 47, 68);
  E12:array[0..11] of integer = (10,12, 15,18, 22,27, 33, 39,47,56, 68,82);
  E24:array[0..23] of integer = (10,11,12,13,15,16,18,20,22,24,27,30,33,36,39,43,47,51,56,62,68,75,82,91);

type
  TFormHvTeiler = class(TForm)
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    LabelStrom: TLabel;
    LabelU2ist: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    LabelR2: TLabel;
    LabelR1: TLabel;
    Shape9: TShape;
    Shape10: TShape;
    LabelU1V: TLabel;
    LabelU2V: TLabel;
    LabelAbweichung: TLabel;
    Label19: TLabel;
    LabelU1ist: TLabel;
    EditUmax: TEdit;
    EditU2: TEdit;
    EditU1: TEdit;
    SpinButtonR2: TSpinButton;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Shape15: TShape;
    EditPmax: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label13: TLabel;
    Shape16: TShape;
    Shape17: TShape;
    Shape18: TShape;
    Shape19: TShape;
    Label14: TLabel;
    Label15: TLabel;
    Shape20: TShape;
    EditRlast: TEdit;
    Shape11: TShape;
    Shape21: TShape;
    Label1: TLabel;
    RadioGroupE: TRadioGroup;
    ListBoxR1: TListBox;
    LabelR2Watt: TLabel;
    LabelR1Watt: TLabel;
    Shape22: TShape;
    LabelR2V: TLabel;
    Label2: TLabel;
    procedure EditUmaxChange(Sender: TObject);
    procedure RadioGroupEClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditRlastChange(Sender: TObject);
    procedure SpinButtonR2UpClick(Sender: TObject);
    procedure SpinButtonR2DownClick(Sender: TObject);
  private
    { Private-Deklarationen }
    u1,u2,r1,rLast, umax,pmax:double;
    r2Obergrenze, Iist:double;
  public
    reihe:array[1..240] of double;
    reiheAnzahl:integer;
    AnzahlR2:integer;
    sucheAufwaerts:boolean;

    function  nextVal(val:string):string;
    function  prevVal(val:string):string;


    procedure erzeugeReihe(e: byte);
    procedure calcHV1;
    function  numToRtxt(val: double): String;
    function  RtxtToNum(txt:string): double;
    function  stromausgabe(i:double):string;
    function spannungsausgabe(u: double): string;
    function  leistungssausgabe(p:double):string;

  end;

var
  FormHvTeiler: TFormHvTeiler;

implementation

{$R *.DFM}

procedure TFormHvTeiler.calcHV1;
var
  r1min,r2min, Ur2, r2,
    bdiff,u2Ist,diff,strom,abweichung:double;
  indexR1Min,indexR2Min, i,j:integer;
  bi, bj:integer; //Bestes i,j
  fertig:boolean;
begin
  try
    u1:=StrToFloat(EditU1.text);
    u2:=StrToFloat(EditU2.text);
    umax:=StrToFloat(EditUmax.text);
    pmax:=StrToFloat(EditPmax.text)/1000;

    if (pmax >0) and (Umax>0) then begin
      AnzahlR2:= ceil(u1 / umax);
      repeat
        fertig:=true;
        Ur2 := u1 / AnzahlR2;
         //P=U*I  I=U/R  P=U*U/R  R=U*U/P
        r2min := Ur2*Ur2 / pmax;
        if r2min>= r2Obergrenze then begin
          inc(AnzahlR2);
          fertig:=false;
        end;
      until fertig;

      r1min := u2*r2min/(u1-u2);
      i:=1;
      while (i<reiheAnzahl) and (reihe[i]<r1min) do inc(i);
      indexR1Min:=i;

      i:=1;
      while (i<reiheAnzahl) and (reihe[i]<r2min) do inc(i);
      indexR2Min:=i;

      bdiff := 1e8;
      bj:=1;
      bi:=1;
        for i:=indexR1Min to reiheAnzahl do begin
          for j:=indexR2Min to reiheAnzahl do begin
            r1:=1/(1/reihe[i] + 1/rLast);
            u2Ist:=u1*r1 / (r1+reihe[j]*AnzahlR2);
            strom:=U1 / (r1+reihe[j]*AnzahlR2);
{            if (strom >= iMin/1000)
            and (strom <= iMax/1000)
            and (strom*strom*reihe[j] < pmax)
            }
            if (strom*strom*reihe[j] < pmax)
            then begin
              diff:=abs(u2Ist-u2);
              if diff <= bdiff then begin
                bdiff:=diff;
                bi:=i;
                bj:=j;
              end;
            end;
          end;
        end;
      if bdiff < 1e8 then begin
        r1:=1/(1/reihe[bi] + 1/rLast);
        r2:=reihe[bj];
        LabelR1.caption:=numToRtxt(reihe[bi]);
        LabelR2.caption:=numToRtxt(reihe[bj]) + '('+intToStr(AnzahlR2)+' Stck)';
        Iist:=U1 / (r1+r2*AnzahlR2);
        labelStrom.caption:=stromausgabe(Iist);
        u2Ist:=u1*r1 / (r1+r2*AnzahlR2);
        labelu2Ist.caption:=spannungsausgabe(u2Ist);
        LabelR2V.caption:=spannungsausgabe(Iist * r2);

        abweichung:=100*((u2Ist-u2)/u2);
        LabelAbweichung.caption:='Abweichung: '+floatToStrF(abweichung, ffFixed,7,2)+'%';

        LabelR1Watt.caption:=leistungssausgabe(Iist*Iist*reihe[bi]);
        LabelR2Watt.caption:=leistungssausgabe(Iist*Iist*r2);
      end;
    end else begin
      Labelu2Ist.caption:='-?-';
      labelStrom.caption:='I=-?-';
      LabelAbweichung.caption:='-?-';
      LabelR1.caption:='-?-';
      LabelR2.caption:='-?-';
    end;
  except
    Labelu2Ist.caption:='-?-';
    labelStrom.caption:='I=-?-';
    LabelAbweichung.caption:='-?-';
    LabelR1.caption:='-?-';
    LabelR2.caption:='-?-';
  end;

end;



procedure TFormHvTeiler.erzeugeReihe(e: byte);
var
  dekade, i:integer;
  mult:double;
begin

  reiheAnzahl:=0;
  listboxR1.clear;
  for dekade:=0 to 6 do begin
    mult:=power(10,dekade);
    case e of
    0: begin
         for i:=low(E6) to high(E6) do begin
           inc(reiheAnzahl);
           reihe[reiheAnzahl] := mult * E6[i];
           listboxR1.items.add(numToRtxt(reihe[reiheAnzahl]));
         end;
         ListBoxR1.ItemIndex:=6*4;
       end;
    1: begin
         for i:=low(E12) to high(E12) do begin
           inc(reiheAnzahl);
           reihe[reiheAnzahl] := mult * E12[i];
           listboxR1.items.add(numToRtxt(reihe[reiheAnzahl]));
         end;
         ListBoxR1.ItemIndex:=12*4;
       end;
    2: begin
         for i:=low(E24) to high(E24) do begin
           inc(reiheAnzahl);
           reihe[reiheAnzahl] := mult * E24[i];
           listboxR1.items.add(numToRtxt(reihe[reiheAnzahl]));
         end;
         ListBoxR1.ItemIndex:=24*4;
       end;
    end;
  end;
end;



function TFormHvTeiler.nextVal(val: string): string;
var
  r:double;
  i:integer;
begin
  r:= RtxtToNum(val);
  i:=1;
  while (i<reiheAnzahl) and (reihe[i] <= r+0.000001) do inc(i);
  result:=numtoRtxt(reihe[i]);

end;

function TFormHvTeiler.numToRtxt(val: double): String;
var
  x,l,r:integer;
begin
  if val >= 1000000 then begin
    x:=round(val);
    l:=x div 1000000;
    r:=x mod 1000000;
    while (0=r mod 10) and (r>0) do r:=r div 10;
    if (r>0)
    then result:=intToStr(l)+'M'+intToStr(r)
    else result:=intToStr(l)+'M';
  end
  else
  if val >= 1000 then begin
    x:=round(val);
    l:=x div 1000;
    r:=x mod 1000;
    while (0=r mod 10) and (r>0) do r:=r div 10;
    if (r>0)
    then result:=intToStr(l)+'K'+intToStr(r)
    else result:=intToStr(l)+'K';
  end
  else begin
    x:=round(val*1000);
    l:=x div 1000;
    r:=x mod 1000;
    result:=intToStr(l)+'R';
    x:=100;
    while (r>0) and (x>0) do begin
      result:= result+intToStr(r div x);
      r:=r mod x;
      x:=x div 10;
    end;
  end;
end;

function TFormHvTeiler.prevVal(val: string): string;
var
  r:double;
  i:integer;
begin
  r:= RtxtToNum(val);
  i:=1;
  while (i<reiheAnzahl) and (reihe[i] < r-0.000001) do inc(i);
  dec(i);
  if i<1 then i:=1;
  result:=numtoRtxt(reihe[i]);
end;

function TFormHvTeiler.RtxtToNum(txt: string): double;
var
  p:integer;
  faktor:double;
begin
  txt:=uppercase(trim(txt));
  faktor:=1;
  p:=pos('M',txt);
  if p>0 then begin
    txt[p]:=decimalseparator;
    faktor:=1e6;
  end;
  p:=pos('K',txt);
  if p>0 then begin
    txt[p]:=decimalseparator;
    faktor:=1e3;
  end;
  p:=pos('R',txt);
  if p>0 then begin
    txt[p]:=decimalseparator;
  end;
  result:=strToFloat(txt)*faktor;
end;

function TFormHvTeiler.spannungsausgabe(u: double): string;
var
  einheit:string;
begin
  einheit:='V';
  if u > 1000 then begin
    u:=u/1000;
    einheit:='KV';
  end;
  if u < 1.0 then begin
    u:=u*1000;
    einheit:='mV';
  end;
  if u < 1.0 then begin
    u:=u*1000;
    einheit:='V';
  end;
  if u < 1.0 then begin
    u:=u*1000;
    einheit:='nV';
  end;
  result:=floatToStrF(u,ffGeneral,7,5)+einheit;
end;

procedure TFormHvTeiler.SpinButtonR2DownClick(Sender: TObject);
begin
  editRLast.text:=prevVal(editRLast.text);
end;

procedure TFormHvTeiler.SpinButtonR2UpClick(Sender: TObject);
begin
  editRLast.text:=nextVal(editRLast.text);
end;

function TFormHvTeiler.stromausgabe(i: double): string;
var
  einheit:string;
begin
  einheit:='A';
  if i > 1000 then begin
    i:=i/1000;
    einheit:='KA';
  end;
  if i < 1.0 then begin
    i:=i*1000;
    einheit:='mA';
  end;
  if i < 1.0 then begin
    i:=i*1000;
    einheit:='A';
  end;
  if i < 1.0 then begin
    i:=i*1000;
    einheit:='nA';
  end;
  result:='I='+floatToStrF(i,ffGeneral,7,5)+einheit;
end;

procedure TFormHvTeiler.EditUmaxChange(Sender: TObject);
begin
  calcHV1;
end;

procedure TFormHvTeiler.RadioGroupEClick(Sender: TObject);
begin
  erzeugeReihe(RadiogroupE.itemindex);
  calcHV1;
end;

procedure TFormHvTeiler.FormCreate(Sender: TObject);
begin
  erzeugeReihe(1);
  r2Obergrenze:=10000000; //10M
  rLast:=1500;
  calcHV1;
end;

function TFormHvTeiler.leistungssausgabe(p: double): string;
var
  einheit:string;
begin
  einheit:='W';
  if p > 1000000 then begin
    p:=p/1000000;
    einheit:='MW';
  end;
  if p > 1000 then begin
    p:=p/1000;
    einheit:='KW';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='mW';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='W';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='nW';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='pW';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='fW';
  end;
  result:=floatToStrF(p,ffGeneral,4,2)+einheit;
end;

procedure TFormHvTeiler.EditRlastChange(Sender: TObject);
begin
  try
    rLast:=RtxtToNum(editRlast.text);
    calcHV1;
  except
  end;  
end;


end.
